var closestCity = null;
var avgPriceReq = null;
var avgPriceCache = new Cache(3);

function City(name, state, min, max)
{
	this.name = name;
	this.state = state;
	this.minZip = min;
	this.maxZip = max;
	
	this.getURL = getURL;
	
	function getURL()
	{
		return "http://www.fuelgaugereport.com/" + state + "metro.asp";
	}
}

function getClosestCity(zip)
{
	cities = getCityList();
	
	var closestCity = null;
	minDist = 99999;
	
	for(var i = 0; i < cities.length; i++)
	{
		var d;
		
		if(zip >= cities[i].minZip)
		{
			if(zip <= cities[i].maxZip)
			{
				cityList = null;
				//alert("*The closest metro area to " + zip + " is " + cities[i].name + ".");
				return cities[i];
			} else
				d = zip - cities[i].maxZip;

		} else
			d = cities[i].minZip - zip;
			
		if(d < minDist)
		{
			minDist = d;
			closestCity = cities[i];
		}
	}
	
	cityList = null;
	//alert("The closest metro area to " + zip + " is " + closestCity.name + ".");
	return closestCity;
}

function getCityList()
{
	var cityList = new Array();
	
 	cityList.push(new City("Birmingham", "AL", 35201, 35299));
 	cityList.push(new City("Huntsville", "AL", 35801, 35899));
 	cityList.push(new City("Mobile", "AL", 36601, 36640));
 	cityList.push(new City("Montgomery", "AL", 36101, 36191));
 	cityList.push(new City("Tuscaloosa", "AL", 35401, 35487));
 	
 	cityList.push(new City("Anchorage", "AK", 99501, 99695));
 	cityList.push(new City("Fairbanks", "AK", 99701, 99790));
 	cityList.push(new City("Juneau", "AK", 99801, 99850));
 	
 	cityList.push(new City("Fayetteville-Springdale-Rogers", "AR", 72701, 72766));
 	cityList.push(new City("Fort Smith", "AR", 72901, 72919));
 	cityList.push(new City("Little Rock-North Little Rock", "AR", 72113, 72295));
 	cityList.push(new City("Pine Bluff", "AR", 71601, 71613));
 	cityList.push(new City("Texarkana", "AR", 71854, 71854));
 	
 	cityList.push(new City("East Valley", "AZ", 85201, 85289));
 	cityList.push(new City("Flagstaff", "AZ", 86001, 86038));
 	cityList.push(new City("Phoenix Proper", "AZ", 85001, 85099));
 	cityList.push(new City("Phoenix-Mesa", "AZ", 85201, 85277));
 	cityList.push(new City("Pima County", "AZ", 85535, 85543));
 	cityList.push(new City("Scottsdale", "AZ", 85250, 85271));
 	cityList.push(new City("Tucson", "AZ", 85701, 85777));
 	cityList.push(new City("Yuma", "AZ", 85364, 85369));
 	cityList.push(new City("West Valley", "AZ", 85301, 85388));
 	
 	cityList.push(new City("Bakersfield", "CA", 93263, 93390));
 	cityList.push(new City("Chico-Paradise", "CA", 95926, 95976));
 	cityList.push(new City("Fresno", "CA", 93650, 93888));
 	cityList.push(new City("Los Angeles-Long Beach", "CA", 90001, 91335));
 	cityList.push(new City("Merced", "CA", 95340, 95348));
 	cityList.push(new City("Modesto", "CA", 95350, 95397));
 	cityList.push(new City("Oakland", "CA", 94601, 94649));
 	cityList.push(new City("Orange County", "CA", 92656, 92887));
 	cityList.push(new City("Redding", "CA", 96001, 96099));
 	cityList.push(new City("Riverside-San Bernardino", "CA", 92401, 92522));
 	cityList.push(new City("Sacramento", "CA", 94203, 95899));
 	cityList.push(new City("Salinas", "CA", 93901, 93962));
 	cityList.push(new City("San Diego", "CA", 92101, 92199));
 	cityList.push(new City("San Francisco", "CA", 94101, 94199));
 	cityList.push(new City("San Jose", "CA", 95101, 95196));
 	cityList.push(new City("San Luis Obispo-Atascadero-Paso Robles", "CA", 93401, 93447));
 	cityList.push(new City("Santa Barbara-Santa Maria-Lompoc", "CA", 93101, 93458));
 	cityList.push(new City("Santa Cruz-Watsonville", "CA", 95060, 95077));
 	cityList.push(new City("Santa Rosa", "CA", 95401, 95409));
 	cityList.push(new City("Stockton-Lodi", "CA", 95201, 95297));
 	cityList.push(new City("Vallejo-Fairfield-Napa", "CA", 94503, 94592));
 	cityList.push(new City("Ventura", "CA", 93001, 93009));
 	cityList.push(new City("Visalia-Tulare-Porterville", "CA", 93257, 93292));
 	cityList.push(new City("Yolo", "CA", 95697, 95697));
 	cityList.push(new City("Yuba City", "CA", 95991, 95993));
 	
 	cityList.push(new City("Boulder-Longmont", "CO", 80301, 80504));
 	cityList.push(new City("Colorado Springs", "CO", 80840, 80925));
 	cityList.push(new City("Denver", "CO", 80002, 80299));
 	cityList.push(new City("Durango", "CO", 81301, 81303));
 	cityList.push(new City("Fort Collins-Loveland", "CO", 80521, 80553));
 	cityList.push(new City("Glenwood Springs", "CO", 81601, 81602));
 	cityList.push(new City("Grand Junction", "CO", 81501, 81506));
 	cityList.push(new City("Greeley", "CO", 80631, 80639));
 	cityList.push(new City("Pueblo", "CO", 81001, 81012));
 	cityList.push(new City("Vail", "CO", 81657, 81658));

	cityList.push(new City("Bridgeport", "CT", 06601, 06699));
 	cityList.push(new City("Hartford", "CT", 06101, 06199));
 	cityList.push(new City("New Haven-Meriden", "CT", 06450, 06540));
 	cityList.push(new City("New London-Norwich", "CT", 06320, 06365));
 	
 	cityList.push(new City("Washington", "DC", 20001, 20599));
 	
 	cityList.push(new City("Dover", "DE", 19901, 19906));
 	cityList.push(new City("Wilmington-Newark", "DE", 19702, 19899));
 	
 	cityList.push(new City("Bradenton-Sarasota-Venice", "FL", 34201, 34282));
 	cityList.push(new City("Daytona Beach", "FL", 32114, 32198));
 	cityList.push(new City("Fort Lauderdale", "FL", 33301, 33394));
 	cityList.push(new City("Fort Myers-Cape Coral", "FL", 33901, 33994));
 	cityList.push(new City("Gainesville", "FL", 32601, 32653));
 	cityList.push(new City("Jacksonville", "FL", 32099, 32290));
 	cityList.push(new City("Miami", "FL", 33010, 33299));
 	cityList.push(new City("Orlando", "FL", 32801, 32899));
 	cityList.push(new City("Pensacola", "FL", 32501, 32592));
 	cityList.push(new City("Tallahassee", "FL", 32301, 32399));
 	cityList.push(new City("Tampa-St. Petersburg-Clearwater", "FL", 33601, 33784));
 	cityList.push(new City("West Palm Beach-Boca Raton", "FL", 33401, 33499));
 	
 	cityList.push(new City("Albany", "GA", 31701, 31721));
 	cityList.push(new City("Athens", "GA", 30601, 30612));
 	cityList.push(new City("Atlanta", "GA", 30301, 30399));
 	cityList.push(new City("Augusta-Aiken", "GA", 30901, 30999));
 	cityList.push(new City("Columbus", "GA", 31829, 31999));
 	cityList.push(new City("Macon", "GA", 31201, 31297));
 	cityList.push(new City("Savannah", "GA", 31401, 31421));
 	cityList.push(new City("Valdosta", "GA", 31601, 31698));
 	
 	cityList.push(new City("Hilo", "HI", 96720, 96721));
 	cityList.push(new City("Honolulu", "HI", 96801, 96850));
 	cityList.push(new City("Wailuku", "HI", 96793, 96793));

	cityList.push(new City("Cedar Rapids", "IA", 52401, 52499));
	cityList.push(new City("Davenport-Moline-Rock Island", "IA", 52801, 52809));
	cityList.push(new City("Des Moines", "IA", 50301, 50398));
 	cityList.push(new City("Sioux City", "IA", 51101, 51111));
 	cityList.push(new City("Waterloo-Cedar Falls", "IA", 50613, 50707));
 	
 	cityList.push(new City("Boise City", "ID", 83701, 83799));
 	cityList.push(new City("Coeur D' Alene", "ID", 83814, 83816));
 	cityList.push(new City("Pocatello", "ID", 83201, 83209));
 	
 	cityList.push(new City("Bloomington-Normal", "IL", 61701, 61799));
	cityList.push(new City("Champaign-Urbana", "IL", 61801, 61826));
	cityList.push(new City("Chicago", "IL", 60601, 60712));
	cityList.push(new City("Danville", "IL", 61832, 61834));
	cityList.push(new City("Davenport-Moline-Rock Island", "IL", 61201, 61299));
	cityList.push(new City("Decatur", "IL", 62521, 62526));
	cityList.push(new City("East Saint Louis", "IL", 62201, 62208));
	cityList.push(new City("Peoria-Pekin", "IL", 61554, 61656));
	cityList.push(new City("Quincy", "IL", 62301, 62306));
	cityList.push(new City("Rockford", "IL", 61101, 61126));
	cityList.push(new City("Springfield", "IL", 62701, 62796));
	
	cityList.push(new City("Bloomington", "IN", 47401, 47490));
	cityList.push(new City("Evansville-Henderson", "IN", 47701, 47750));
	cityList.push(new City("Fort Wayne", "IN", 46801, 46899));
	cityList.push(new City("Gary", "IN", 46401, 46411));
	cityList.push(new City("Indianapolis", "IN", 46201, 46298));
	cityList.push(new City("South Bend", "IN", 46601, 46699));
	cityList.push(new City("Terre Haute", "IN", 47801, 47814));
	
	cityList.push(new City("Kansas City", "KS", 66101, 66160));
	cityList.push(new City("Lawrence", "KS", 66044, 66049));
	cityList.push(new City("Topeka", "KS", 66601, 66699));
	cityList.push(new City("Wichita", "KS", 67201, 67278));
	
	cityList.push(new City("Covington", "KY", 41011, 41019));
	cityList.push(new City("Huntington-Ashland", "KY", 41101, 41114));
	cityList.push(new City("Huntington-Ashland", "KY", 25701, 25725));
	cityList.push(new City("Lexington", "KY", 40502, 40598));
	cityList.push(new City("louisville", "KY", 40201, 40299));
	cityList.push(new City("Owensboro", "KY", 42301, 42304));
	
	cityList.push(new City("Baton Rouge", "LA", 70801, 70898));
	cityList.push(new City("Lafayette", "LA", 70501, 70598));
	cityList.push(new City("Lake Charles", "LA", 70601, 70629));
	cityList.push(new City("New Orleans", "LA", 70112, 70195));
	cityList.push(new City("Shreveport-Bossier City", "LA", 71101, 71172));	
	
	cityList.push(new City("Barnstable-Yarmouth", "MA", 02630, 02675));
	cityList.push(new City("Boston", "MA", 02108, 02298));
	cityList.push(new City("Pittsfield", "MA", 01201, 01203));
	cityList.push(new City("Springfield", "MA", 01101, 01199));
	
	cityList.push(new City("Baltimore", "MD", 21201, 21298));
	cityList.push(new City("Cumberland", "MD", 21501, 21505));
	cityList.push(new City("Hagerstown", "MD", 21740, 21749));
	cityList.push(new City("Salisbury", "MD", 21801, 21804));
	
	cityList.push(new City("Bangor", "ME", 04401, 04402));
	cityList.push(new City("Lewiston-Auburn", "ME", 04210, 04243));
	cityList.push(new City("Portland", "ME", 04101, 04124));
	
	cityList.push(new City("Ann Arbor", "MI", 48103, 48113));
	cityList.push(new City("Benton Harbor", "MI", 49022, 49023));
	cityList.push(new City("Detroit", "MI", 48201, 48288));
	cityList.push(new City("Flint", "MI", 48501, 48599));
	cityList.push(new City("Grand Rapids-Muskegon-Holland", "MI", 49422, 49599));
	cityList.push(new City("Jackson", "MI", 49201, 49204));
	cityList.push(new City("Lansing-East Lansing", "MI", 48823, 48980));
	cityList.push(new City("Saginaw-Bay City-Midland", "MI", 48601, 48710));
	cityList.push(new City("Traverse City", "MI", 49684, 49696));
	
	cityList.push(new City("Duluth-Superior", "MN", 55701, 55816));
	cityList.push(new City("Minneapolis-St. Paul", "MN", 55101, 55191));
	cityList.push(new City("Minneapolis-St. Paul", "MN", 55401, 55488));
	cityList.push(new City("Rochester", "MN", 55901, 55906));
	cityList.push(new City("St. Cloud", "MN", 56301, 56399));
	
	cityList.push(new City("Columbia", "MO", 65201, 65299));
	cityList.push(new City("Kansas City", "MO", 64101, 64199));
	cityList.push(new City("Springfield", "MO", 65801, 65899));
	cityList.push(new City("St. Joseph", "MO", 64501, 64508));
	cityList.push(new City("St. Louis", "MO", 63101, 63199));
	
	cityList.push(new City("Biloxi-Gulfport-Pascagoula", "MS", 39501, 39595));
	cityList.push(new City("Jackson", "MS", 39201, 39298));
	
	cityList.push(new City("Billings", "MT", 59101, 59117));
	cityList.push(new City("Great Falls", "MT", 59401, 59406));
	cityList.push(new City("Missoula", "MT", 59801, 59812));
	
	cityList.push(new City("Asheville", "NC", 28801, 28816));
	cityList.push(new City("Charlotte-Gastonia-Rock Hill", "NC", 28052, 28056));
	cityList.push(new City("Charlotte-Gastonia-Rock Hill", "NC", 28201, 28299));
	cityList.push(new City("Fayetteville", "NC", 28301, 28314));
	cityList.push(new City("Greensboro--Winston-Salem--High Point", "NC", 27101, 27499));
	cityList.push(new City("Raleigh-Durham-Chapel Hill", "NC", 27514, 27722));
	cityList.push(new City("Wilmington", "NC", 28401, 28412));
	
	cityList.push(new City("Bismarck", "ND", 58501, 58507));
	cityList.push(new City("Fargo-Moorhead", "ND", 58102, 58126));
	cityList.push(new City("Grand Forks", "ND", 58201, 58208));
	
	cityList.push(new City("Columbus", "NE", 68601, 68602));
	cityList.push(new City("Grand Island", "NE", 68801, 68803));
	cityList.push(new City("Kearney", "NE", 68845, 68849));
	cityList.push(new City("Lincoln", "NE", 68501, 68588));
	cityList.push(new City("Norfolk", "NE", 68701, 68702));
	cityList.push(new City("North Platte", "NE", 69101, 69103));
	cityList.push(new City("Omaha", "NE", 68101, 68198));
	
	cityList.push(new City("Manchester", "NH", 03101, 03111));
	cityList.push(new City("Portsmouth-Rochester", "NH", 03801, 03868));
	
	cityList.push(new City("Atlantic-Cape May", "NJ", 08201, 08406));
	cityList.push(new City("Bergen-Passaic", "NJ", 07010, 07699));
	cityList.push(new City("Middlesex-Somerset-Hunterdon", "NJ", 08801, 08989));
	cityList.push(new City("Monmouth-Ocean", "NJ", 07701, 07799));
	cityList.push(new City("Newark", "NJ", 07101, 07199));
	cityList.push(new City("Philadelphia", "NJ", 0, 0));
	cityList.push(new City("Trenton", "NJ", 08601, 08695));
	
	cityList.push(new City("Albequerque", "NM", 87101, 87199));
	cityList.push(new City("Las Cruces", "NM", 88001, 88013));
	cityList.push(new City("Santa Fe", "NM", 87501, 87594));
	
	cityList.push(new City("Las Vegas", "NV", 89044, 89199));
	cityList.push(new City("Reno", "NV", 89501, 89599));
	
	cityList.push(new City("Albany-Schenectady-Troy", "NY", 12180, 12345));
	cityList.push(new City("Binghamton", "NY", 13901, 13905));
	cityList.push(new City("Buffalo-Niagara Falls", "NY", 14201, 14305));
	cityList.push(new City("Nassau-Suffolk", "NY", 12123, 12123));
	cityList.push(new City("New York", "NY", 10001, 10292));
	cityList.push(new City("Rochester", "NY", 14602, 14694));
	cityList.push(new City("Syracuse", "NY", 13201, 13290));
	cityList.push(new City("Utica-Rome", "NY", 13440, 13599));
	
	cityList.push(new City("Akron", "OH", 44301, 44399));
	cityList.push(new City("Canton-Massillon", "OH", 44646, 44799));
	cityList.push(new City("Cincinnati", "OH", 45201, 45299));
	cityList.push(new City("Cleveland-Lorain-Elyria", "OH", 44035, 44199));
	cityList.push(new City("Columbus", "OH", 43201, 43299));
	cityList.push(new City("Dayton-Springfield", "OH", 45390, 45506));
	cityList.push(new City("Toledo", "OH", 43601, 43699));
	cityList.push(new City("Youngstown-Warren", "OH", 44481, 44555));
	
	cityList.push(new City("Oklahoma City", "OK", 73101, 73199));
	cityList.push(new City("Tulsa", "OK", 74101, 74194));
	
	cityList.push(new City("Eugene-Springfield", "OR", 97401, 97482));
	cityList.push(new City("Medford-Ashland", "OR", 97501, 97520));
	cityList.push(new City("Portland-Vancouver", "OR", 97201, 97299));
	cityList.push(new City("Salem", "OR", 97301, 97317));
	
	cityList.push(new City("Allentown-Bethlehem-Easton", "PA", 18015, 18195));
	cityList.push(new City("Erie", "PA", 16501, 16565));
	cityList.push(new City("Harrisburg-Lebanon-Carlisle", "PA", 17013, 17177));
	cityList.push(new City("Lancaster", "PA", 17573, 17699));
	cityList.push(new City("Philadelphia", "PA", 19019, 19255));
	cityList.push(new City("Pittsburgh", "PA", 15122, 15295));
	cityList.push(new City("Reading", "PA", 19601, 19640));
	cityList.push(new City("Scranton--Wilkes-Barre-Hazleton", "PA", 18201, 18202));
	cityList.push(new City("Scranton--Wilkes-Barre-Hazleton", "PA", 18501, 18577));
	cityList.push(new City("Scranton--Wilkes-Barre-Hazleton", "PA", 18701, 18773));
	cityList.push(new City("York", "PA", 17315, 17415));
	
	cityList.push(new City("Providence-Fall River-Warwick", "RI", 02801, 02940));
	
	cityList.push(new City("Charleston-North Charleston", "SC", 29401, 29492));
	cityList.push(new City("Columbia", "SC", 29201, 29292));
	cityList.push(new City("Greenville-Spartanburg-Anderson", "SC", 29601, 29698));
	cityList.push(new City("Greenville-Spartanburg-Anderson", "SC", 29301, 29319));
	cityList.push(new City("Myrtle Beach", "SC", 29572, 29588));
	
	cityList.push(new City("Rapid City", "SD", 57701, 57709));
	cityList.push(new City("Sioux Falls", "SD", 57101, 57198));
	
	cityList.push(new City("Chattanooga", "TN", 37401, 37450));
	cityList.push(new City("Clarksville-Hopkinsville", "TN", 37040, 37044));
	cityList.push(new City("Jackson City-Kingsport-Bristol", "TN", 37620, 37669));
	cityList.push(new City("Knoxville", "TN", 37901, 37998));
	cityList.push(new City("Memphis", "TN", 38101, 38197));
	cityList.push(new City("Nashville", "TN", 37201, 37250));
	
	cityList.push(new City("Amarillo", "TX", 79101, 79189));
	cityList.push(new City("Austin-San Marcos", "TX", 78666, 78799));
	cityList.push(new City("Beaumont-Port Arthur", "TX", 77640, 77726));
	cityList.push(new City("Corpus Christi", "TX", 78401, 78480));
	cityList.push(new City("Dallas", "TX", 75201, 75398));
	cityList.push(new City("El Paso", "TX", 79901, 79999));
	cityList.push(new City("El Paso", "TX", 88510, 88595));
	cityList.push(new City("Forth Worth-Arlington", "TX", 76001, 76126));
	cityList.push(new City("Galveston-Texas City", "TX", 77550, 77592));
	cityList.push(new City("Houston", "TX", 77001, 77299));
	cityList.push(new City("San Antonio", "TX", 78201, 78299));
	cityList.push(new City("Texarkana", "TX", 75501, 75599));
	
	cityList.push(new City("Provo-Orem", "UT", 85601, 84606));
	cityList.push(new City("Provo-Orem", "UT", 84057, 84097));
	cityList.push(new City("Salt Lake City-Ogden", "UT", 84101, 84415));
	
	cityList.push(new City("Charlottesville", "VA", 22901, 22911));
	cityList.push(new City("Norfolk-Virginia Beach-Newport News", "VA", 23450, 23630));
	cityList.push(new City("Richmond-Petersburg", "VA", 23173, 23298));
	cityList.push(new City("Roanoke", "VA", 24001, 24157));
	
	cityList.push(new City("Burlington", "VT", 05401, 05408));
	
	cityList.push(new City("Bellingham", "WA", 98225, 98229));
	cityList.push(new City("Bremerton", "WA", 98310, 98337));
	cityList.push(new City("Olympia", "WA", 98501, 98599));
	cityList.push(new City("Richland-Kennewick-Pasco", "WA", 99301, 99354));
	cityList.push(new City("Seattle-Bellevue-Everett", "WA", 98004, 98213));
	cityList.push(new City("Spokane", "WA", 99201, 99299));
	cityList.push(new City("Tacoma", "WA", 98401, 98499));
	cityList.push(new City("Vancouver", "WA", 98660, 98687));
	cityList.push(new City("Yakima", "WA", 98901, 98909));
	
	cityList.push(new City("Eau Claire", "WI", 54701, 54703));
	cityList.push(new City("Green Bay", "WI", 54301, 54344));
	cityList.push(new City("Janesville-Beloit", "WI", 53511, 53548));
	cityList.push(new City("La Crosse", "WI", 54601, 54603));
	cityList.push(new City("Madison", "WI", 53701, 53794));
	cityList.push(new City("Milwaukee-Waukesha", "WI", 53201, 53295));
	
	cityList.push(new City("Charleston", "WV", 25301, 25396));
	cityList.push(new City("Huntington-Ashland", "WV", 25701, 25779));
	cityList.push(new City("Huntington-Ashland", "WV", 24868, 24868));
	cityList.push(new City("Parkersburg-Marietta", "WV", 26101, 26106));
	cityList.push(new City("Steubenville-Weirton", "WV", 26062, 26062));
	cityList.push(new City("Wheeling", "WV", 26003, 26003));

	cityList.push(new City("Casper", "WY", 82601, 82646));
	cityList.push(new City("Cheyenne", "WY", 82001, 82010));
	
	return cityList;
}

function avgPriceForGrade(grade)
{
	var zipcode = $("zipcode").value;

	if(!closestCity)
		closestCity = getClosestCity(zipcode);
		
	//check the cache
	avgPrices = avgPriceCache.lookup(zipcode);
	
	if(avgPrices)
		return avgPrice = avgPrices[grade];

	//query the data
	if(!avgPriceReq)
	{
		avgPriceReq = new XMLHttpRequest();
		avgPriceReq.open("POST", closestCity.getURL(), true);
    	avgPriceReq.onreadystatechange = receiveAvgPriceResponse;
    	avgPriceReq.send(null);
    }
    
    return null; //no result to return yet
}

function receiveAvgPriceResponse()
{
    //check for a completed request
	if(avgPriceReq.readyState == 4 && avgPriceReq.status == 200)
	{
		parseAvgPrice(avgPriceReq.responseText);
	}
}

function parseAvgPrice(HTML)
{
	var avgPrice = new Array();
	
	var pattern = new RegExp("(b|strong)\>\s*" + closestCity.name + "[\\s\\S]*?Yesterday", "i");
	var HTML = HTML.match(pattern)[0];
	var HTML = HTML.match(/Current[\s\S]*/mi)[0];
	var prices = HTML.match(/\d\.\d+/g);
	
	alert(prices);
	
	//parse stuff here...
	avgPrice["regular"] = (prices.length > 0) ? prices[0] : "0";
	avgPrice["plus"] = (prices.length > 1) ? prices[1] : "0";
	avgPrice["premium"] = (prices.length > 2) ? prices[2] : "0";
	avgPrice["diesel"] = (prices.length > 3) ? prices[3] : "0";
	
	avgPriceCache.insert(avgPrice, $("zipcode").value, 43200);
	avgPriceReq = null;
}